# Quick TODO list

*P* = pending; *W* = working on it; *D* = done.

## Critical for MVP

- *D* LMDB back end
- *D* Hash table back end
- *D* Namespace manager
- *D* N3 serialization / deserialization
- *D* Environment
- *D* Better error handling
- *D* Logging
- *D* Store graph
- *D* Python bindings
    - *D* Basic module framework
    - *D* term, triple, graph modules
    - *D* Codec integration
    - *D* Graph remove and lookup ops
    - *D* Namespace module
    - *D* Tests (basic)
    - *D* Subclass term types
- *P* Turtle serialization / deserialization
- *P* Extended tests
    - *P* C API
    - *P* Python API


## Non-critical for MVP

- Term and triple validation
- Enhanced graph operations
    - Extract unique terms and 2-term tuples
- NQ codec
- TriG codec


## Long-term

- Generic graph (non RDF constrained)
- Lua bindings
